<?php

namespace CorporateTrainingBundle\Biz\AdvancedMemberSelect;

use AppBundle\Common\Exception\AccessDeniedException;
use Codeages\Biz\Framework\Context\Biz;

abstract class AbstractMemberSelect
{
    protected $biz;

    abstract public function canSelect($targetId);

    abstract public function becomeMember($targetId, $userIds);

    public function __construct(Biz $biz)
    {
        $this->biz = $biz;
    }

    public function selectUserIds($targetId, $userIds)
    {
        if (!$this->canSelect($targetId)) {
            throw new AccessDeniedException('Access Denied');
        }

        if (empty($targetId) || empty($userIds)) {
            return false;
        }

        if (!is_array($userIds)) {
            $userIds = explode(',', $userIds);
        }

        return $this->becomeMember($targetId, $userIds);
    }

    protected function createService($alias)
    {
        return $this->biz->service($alias);
    }
}
