<?php

namespace CorporateTrainingBundle\Biz\Classroom\Service\Impl;

use Biz\Classroom\Service\Impl\ClassroomServiceImpl as BaseService;

class ClassroomServiceImpl extends BaseService
{
    public function findClassroomCoursesByClassroomIds(array $classroomIds)
    {
        return $this->getClassroomCourseDao()->findByClassroomIds($classroomIds);
    }

    public function initOrgsRelation()
    {
        $fields = array('1', '1.');

        return $this->getClassroomDao()->initOrgsRelation($fields);
    }

    /**
     * @param  $id
     * @param  $permission
     *
     * @return bool
     */
    public function canManageClassroom($id, $permission = 'admin_classroom_content_manage')
    {
        $classroom = $this->getClassroom($id);

        if (empty($classroom)) {
            return false;
        }

        $user = $this->getCurrentUser();
        if (!$user->isLogin()) {
            return false;
        }

        if (!in_array($classroom['orgId'], $user['accessibleOrgIds'])) {
            return false;
        }

        if ($user->isAdmin()) {
            return true;
        }

        if ($user->hasPermission($permission)) {
            return true;
        }

        $member = $this->getClassroomMember($id, $user['id']);

        if (empty($member)) {
            return false;
        }

        if (in_array('headTeacher', $member['role'])) {
            return true;
        }

        return false;
    }
}
