<?php

namespace CorporateTrainingBundle\Biz\Course\Event;

use AppBundle\Common\ArrayToolkit;
use Biz\Course\Dao\CourseDao;
use Codeages\Biz\Framework\Event\Event;
use Codeages\PluginBundle\Event\EventSubscriber;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class CourseEventSubscriber extends EventSubscriber implements EventSubscriberInterface
{
    public static function getSubscribedEvents()
    {
        return array(
            'course-set.update' => 'onCourseSetUpdate',
        );
    }

    public function onCourseSetUpdate(Event $event)
    {
        $courseSet = $event->getSubject();

        if (empty($courseSet['defaultCourseId'])) {
            return;
        }

        $copyFields = array_filter(
            ArrayToolkit::parts(
                $courseSet,
                array(
                    'title',
                    'categoryId',
                    'summary',
                    'goals',
                    'audiences',
                    'serializeMode',
                )
            )
        );

        $this->getCourseDao()->update($courseSet['defaultCourseId'], $copyFields);
    }

    /**
     * @return CourseDao
     */
    protected function getCourseDao()
    {
        return $this->getBiz()->dao('Course:CourseDao');
    }
}
