<?php

namespace CorporateTrainingBundle\Biz\Crontab;

use Biz\Crontab\SystemCrontabInitializer as BaseCrontabInitializer;

class SystemCrontabInitializer extends BaseCrontabInitializer
{
    protected static function registerDefaultJobs()
    {
        parent::registerDefaultJobs();

        $count = self::getSchedulerService()->countJobs(
            array('name' => 'SyncMaxUsersNumberJob', 'source' => 'TRAININGMAIN')
        );
        if ($count == 0) {
            self::getSchedulerService()->register(
                array(
                    'name' => 'SyncMaxUsersNumberJob',
                    'source' => 'TRAININGMAIN',
                    'expression' => '0 * * * *',
                    'class' => 'CorporateTrainingBundle\Biz\User\Job\SyncMaxUsersNumberJob',
                    'args' => array(),
                    'misfire_policy' => 'executing',
                )
            );
        }

        $count = self::getSchedulerService()->countJobs(
            array('name' => 'PreSyncUserLearnReportJob', 'source' => 'TRAININGMAIN')
        );
        if ($count == 0) {
            self::getSchedulerService()->register(
                array(
                    'name' => 'PreSyncUserLearnReportJob',
                    'source' => 'TRAININGMAIN',
                    'expression' => '0 0 * * *',
                    'class' => 'CorporateTrainingBundle\Biz\DataStatistics\Job\PreSyncUserLearnReportJob',
                    'args' => array(),
                    'misfire_policy' => 'executing',
                )
            );
        }
    }
}
