<?php

namespace CorporateTrainingBundle\Biz\DataStatistics\Dao\Impl;

use Codeages\Biz\Framework\Dao\GeneralDaoImpl;
use CorporateTrainingBundle\Biz\DataStatistics\Dao\UserLearnReportDao;

class UserLearnReportDaoImpl extends GeneralDaoImpl implements UserLearnReportDao
{
    protected $table = 'user_learn_report';

    public function getByUserId($userId)
    {
        return $this->getByFields(array('userId' => $userId));
    }

    public function declares()
    {
        return array(
            'timestamps' => array(
                'createdTime',
                'updatedTime',
            ),
            'orderbys' => array(
                'id',
                'createdTime',
                'updatedTime',
            ),
            'conditions' => array(
                'id =: id',
                'userId = :userId',
                'postId = :postId',
                'userId IN ( :userIds )',
            ),
        );
    }
}
