<?php

namespace CorporateTrainingBundle\Biz\DataStatistics\Dao;

use Codeages\Biz\Framework\Dao\GeneralDaoInterface;

interface UserDailyLearnRecordDao extends GeneralDaoInterface
{
    public function getByUserIdAndCourseId($userId, $courseId);

    public function getByUserIdAndCourseIdAndCourseStatus($userId, $courseId, $courseStatus);

    public function waveLearnTimeById($id, $learnTime);

    public function waveFinishedTaskNum($id, $finishedTaskNum);

    public function getByUserIdAndCourseIdAndDate($userId, $courseId, $date);

    public function sumLearnTimeByUserId($userId);

    public function sumPostLearnTimeByUserIdAndPostId($userId, $postId);

    public function statisticsUsersLearnTimeByDateGroupByUserId($date);

    public function statisticsLearnRecordGroupByUserId(array $conditions);

    public function statisticsLearnRecordGroupByOrgId(array $conditions);

    public function statisticsLearnRecordGroupByPostId(array $conditions);

    public function statisticsLearnRecordGroupByCategoryId(array $conditions);

    public function statisticsOrgLearnTimeRankingList(array $conditions, $start = 0, $limit = 5);

    public function statisticsPersonLearnTimeRankingList(array $conditions, $start = 0, $limit = 5);

    public function statisticsLearnCourseRankingList(array $conditions, $start = 0, $limit = 5);

    public function statisticsFinishedCourseNumAndLearnTime(array $conditions);

    public function statisticsTotalLearnTimeGroupByDate(array $conditions);

    public function findLearnUserIds(array $conditions);

    public function statisticsLearnUsersNumGroupByDate(array $conditions);
}
