<?php

namespace CorporateTrainingBundle\Biz\DataStatistics\EventProcessor;

use AppBundle\Common\Exception\InvalidArgumentException;
use Topxia\Service\Common\ServiceKernel;

class EventProcessorFactory
{
    private static $map = array(
        'course.join' => 'CorporateTrainingBundle\\Biz\\DataStatistics\\EventProcessor\\CourseJoinProcessor',
        'course.view' => 'CorporateTrainingBundle\\Biz\\DataStatistics\\EventProcessor\\CourseViewProcessor',
        'task.view' => 'CorporateTrainingBundle\\Biz\\DataStatistics\\EventProcessor\\TaskViewProcessor',
        'task.finish' => 'CorporateTrainingBundle\\Biz\\DataStatistics\\EventProcessor\\TaskFinishProcessor',
        'wave.learn.time' => 'CorporateTrainingBundle\\Biz\\DataStatistics\\EventProcessor\\WaveLearnTimeProcessor',
    );

    public static function create($method)
    {
        if (!array_key_exists($method, self::$map)) {
            throw new InvalidArgumentException(sprintf('Unknown method type: %s', $method));
        }

        $processor = self::$map[$method];

        return new $processor(ServiceKernel::instance()->getBiz());
    }
}
