<?php

namespace CorporateTrainingBundle\Biz\DataStatistics\Service;

interface UserDailyLearnRecordService
{
    public function getDailyRecord($id);

    public function createDailyRecord(array $dailyRecord);

    public function createCurrentDateDailyRecord(array $dailyRecord);

    public function updateDailyRecord($id, array $fields);

    public function countRecords(array $conditions);

    public function searchRecords(array $conditions, array $orderBys, $start, $limit);

    public function getRecordByUserIdAndCourseId($userId, $courseId);

    public function getTodayRecordByUserIdAndCourseId($userId, $courseId);

    public function getRecordByUserIdAndCourseIdAndCourseStatus($userId, $courseId, $status);

    public function getRecordByUserIdAndCourseIdAndDate($userId, $courseId, $date);

    public function waveLearnTimeById($id, $learnTime);

    public function waveFinishedTaskNumById($id);

    public function sumLearnTimeByUserId($userId);

    public function sumPostLearnTimeByUserIdAndPostId($userId, $postId);

    public function statisticsUsersLearnTimeByDateGroupByUserId($date);

    public function statisticsLearnRecordGroupByUserId(array $conditions);

    public function statisticsLearnRecordGroupByOrgId(array $conditions);

    public function statisticsLearnRecordGroupByPostId(array $conditions);

    public function statisticsLearnRecordGroupByCategoryId(array $conditions);

    public function statisticsOrgLearnTimeRankingList(array $conditions, $start = 0, $limit = 5);

    public function statisticsPersonLearnTimeRankingList(array $conditions, $start = 0, $limit = 5);

    public function statisticsLearnCourseRankingList(array $conditions, $start = 0, $limit = 5);

    public function statisticsFinishedCourseNumAndLearnTime(array $conditions);

    public function statisticsLearnUsersNumGroupByDate(array $conditions);

    public function statisticsTotalLearnTimeGroupByDate(array $conditions);

    public function findLearnUserIdsByDate($startDate, $endDate);
}
