<?php

namespace CorporateTrainingBundle\Biz\Exporter;

use AppBundle\Extension\Extension;
use Pimple\Container;
use Pimple\ServiceProviderInterface;

class ExportServiceProvider extends Extension implements ServiceProviderInterface
{
    public function register(Container $biz)
    {
        $this->registerExportType($biz);
        $biz['export_factory'] = function ($biz) {
            $exporter = new ExporterFactory();
            $exporter->setBiz($biz);

            return $exporter;
        };
    }

    protected function registerExportType($biz)
    {
        $biz['export.offline_course_member'] = function ($biz) {
            return new OfflineCourseMemberExporter($biz);
        };

        $biz['export.batch_grade_example'] = function ($biz) {
            return new OfflineCourseBatchGradeExampleExporter($biz);
        };

        $biz['export.data_statistic_person'] = function ($biz) {
            return new DataStatisticPersonExporter($biz);
        };

        $biz['export.data_statistic_department'] = function ($biz) {
            return new DataStatisticDepartmentExporter($biz);
        };

        $biz['export.data_statistic_post'] = function ($biz) {
            return new DataStatisticPostExporter($biz);
        };

        $biz['export.data_statistic_category'] = function ($biz) {
            return new DataStatisticCategoryExporter($biz);
        };

        $biz['export.data_user_learn'] = function ($biz) {
            return new DataUserLearnExporter($biz);
        };

        $biz['export.training_assignment_member'] = function ($biz) {
            return new  TrainingAssignmentMemberExporter($biz);
        };
    }
}
