<?php

namespace CorporateTrainingBundle\Biz\OfflineCourse\Dao\Impl;

use Codeages\Biz\Framework\Dao\GeneralDaoImpl;
use CorporateTrainingBundle\Biz\OfflineCourse\Dao\EnrollmentRecordDao;

class EnrollmentRecordDaoImpl extends GeneralDaoImpl implements EnrollmentRecordDao
{
    protected $table = 'offline_course_enrollment_record';

    public function getLatestByCourseIdAndUserId($courseId, $userId)
    {
        $sql = "SELECT * FROM {$this->table} WHERE offlineCourseId = ? AND userId = ? ORDER BY submittedTime DESC limit 1";

        return $this->db()->fetchAssoc($sql, array($courseId, $userId));
    }

    public function statisticsSubmittedStudentNum($courseId)
    {
        $sql = "SELECT count(*)  FROM {$this->table} WHERE offlineCourseId = ? AND status = 'submitted' GROUP BY userId ";

        return $this->db()->fetchColumn($sql, array($courseId)) ?: 0;
    }

    public function findByCourseId($courseId)
    {
        return $this->findByFields(array(
        'offlineCourseId' => $courseId,
    ));
    }

    public function deleteByCourseIdAndUserId($courseId, $userId)
    {
        return $this->db()->delete($this->table, array('offlineCourseId' => $courseId, 'userId' => $userId));
    }

    public function declares()
    {
        return array(
            'timestamps' => array('submittedTime', 'updatedTime'),
            'serializes' => array(),
            'orderbys' => array('id', 'submittedTime', 'approvedTime', 'updatedTime'),
            'conditions' => array(
                'status = :status',
                'userId = :userId',
                'offlineCourseId = :offlineCourseId',
                'userId IN ( :userIds)',
                'offlineCourseId IN ( :offlineCourseIds)',
            ),
        );
    }
}
