<?php

namespace CorporateTrainingBundle\Biz\OfflineCourse\Dao\Impl;

use Codeages\Biz\Framework\Dao\GeneralDaoImpl;
use CorporateTrainingBundle\Biz\OfflineCourse\Dao\OfflineCourseDao;

class OfflineCourseDaoImpl extends GeneralDaoImpl implements OfflineCourseDao
{
    protected $table = 'offline_course';

    public function findOfflineCoursesByIds($ids)
    {
        return $this->findInField('id', $ids);
    }

    public function declares()
    {
        return array(
            'timestamps' => array('createdTime', 'updatedTime'),
            'serializes' => array('cover' => 'json'),
            'orderbys' => array('id', 'createdTime', 'updatedTime', 'enrollmentEndDate', 'endDate', 'startDate'),
            'conditions' => array(
                'title LIKE :title',
                'categoryId = :categoryId',
                'parentId = :parentId',
                'orgCode = :orgCode',
                'orgCode LIKE :likeOrgCode',
                'endDate >= :endDate_GE',
                'endDate <= :endDate_LE',
                'startDate >= :startDate_GE',
                'startDate <= :startDate_LE',
                'enrollmentEndDate >= :enrollmentEndDate_GE',
                'enrollmentEndDate <= :enrollmentEndDate_LE',
                'status = :status',
                'categoryId IN ( :categoryIds)',
                'id IN ( :ids)',
            ),
        );
    }
}
