<?php

namespace CorporateTrainingBundle\Biz\OfflineCourse\Service;

interface EnrollmentRecordService
{
    public function createEnrollmentRecord($record);

    public function updateEnrollmentRecord($id, $fields);

    public function getEnrollmentRecord($id);

    public function countEnrollmentRecords(array $conditions);

    public function searchEnrollmentRecords(array $conditions, array $orderBys, $start, $limit);

    public function getLatestEnrollmentRecordByCourseIdAndUserId($courseId, $userId);

    public function passOfflineCourseApply($recordId);

    public function rejectOfflineCourseApply($recordId, $info = array());

    public function batchPass($recordIds);

    public function batchReject($recordIds);

    public function statisticsOfflineCourseSubmittedStudentNum($courseId);

    public function findEnrollmentRecordsByCourseId($courseId);

    public function deleteEnrollmentRecordByCourseIdAndUserId($courseId, $userId);
}
