<?php

namespace CorporateTrainingBundle\Biz\OfflineCourse\Service;

interface MemberService
{
    public function createMember($member);

    public function updateMember($id, $fields);

    public function deleteMember($id);

    public function getMember($memberId);

    public function countMembers($conditions);

    public function searchMembers(array $conditions, array $orderBys, $start, $limit);

    public function findMembersByOfflineCourseId($courseId);

    public function getMemberByCourseIdAndUserId($courseId, $userId);

    public function becomeMember($courseId, $userId);

    public function becomeMemberByImport($courseId, $userId);

    public function isMember($courseId, $userId);

    public function attendMember($id, $attendedStatus);

    public function signIn($id);

    public function gradeMember($id, $fields);

    public function removeMember($id);

    public function statisticMembersAttendStatusByCourseId($courseId);

    public function statisticMemberPassStatusByCourseId($courseId);

    public function statisticMemberScoreByCourseId($courseId);

    public function findDistinctUserIdsByDate($startDate, $endDate);
}
