<?php

namespace CorporateTrainingBundle\Biz\Org\Service;

use Biz\Org\Service\OrgService as BaseInterface;

interface OrgService extends BaseInterface
{
    /**
     *  遍历获取某一组织机构的父级及自己
     *  如果没有传orgcode, 默认不返回数据.
     */
    public function findSelfAndParentOrgsByOrgCode($orgCode);

    public function buildOrgTreeByCode($orgCode);

    public function countOrgs(array $conditions);

    public function findOrgsByPrefixOrgCodes(array $orgCodes = array('1.'));

    public function getVisibleOrgTreeDataByOrgCodes(array $orgCodes, $filter = false);

    public function buildVisibleOrgTreeByOrgCodes(array $orgCodes);

    public function resetOrg();

    public function createOrg($org);

    public function updateOrg($id, $fields);

    public function deleteOrg($id);

    public function getOrgBySyncId($syncId);

    public function findOrgsBySyncIds($syncIds);

    public function findOrgsByCodes(array $codes);
}
