<?php

namespace CorporateTrainingBundle\Biz\Task\Service\Impl;

use Biz\Task\Service\Impl\TaskResultServiceImpl as BaseTaskResultServiceImpl;
use Codeages\Biz\Framework\Event\Event;
use CorporateTrainingBundle\Biz\Task\Service\TaskResultService;

class TaskResultServiceImpl extends BaseTaskResultServiceImpl implements TaskResultService
{
    public function getTaskResultByTaskIdAndUserId($taskId, $userId)
    {
        return $this->getTaskResultDao()->getByTaskIdAndUserId($taskId, $userId);
    }

    public function sumLearnTimeByPostIdAndUserId($postId, $userId)
    {
        return $this->getTaskResultDao()->sumLearnTimeByPostIdAndUserId($postId, $userId);
    }

    public function sumLearnTimeByUserId($userId)
    {
        return $this->getTaskResultDao()->sumLearnTimeByUserId($userId);
    }

    public function sumLearnTimeByTaskIdAndUserId($taskId, $userId)
    {
        return $this->getTaskResultDao()->sumLearnTimeByTaskIdAndUserId($taskId, $userId);
    }

    public function sumLearnTimeByCategoryIdAndUserId($categoryId, $userId)
    {
        return $this->getTaskResultDao()->sumLearnTimeBycategoryIdAndUserId($categoryId, $userId);
    }

    public function sumWatchTimeByCourseIdAndUserId($courseId, $userId)
    {
        return $this->getTaskResultDao()->sumWatchTimeByCourseIdAndUserId($courseId, $userId);
    }

    public function sumWatchTimeByTaskIdAndUserId($taskId, $userId)
    {
        return $this->getTaskResultDao()->sumWatchTimeByTaskIdAndUserId($taskId, $userId);
    }

    public function sumWatchTimeByPostIdAndUserId($postId, $userId)
    {
        return $this->getTaskResultDao()->sumWatchTimeByPostIdAndUserId($postId, $userId);
    }

    public function sumWatchTimeByCategoryIdAndUserId($categoryId, $userId)
    {
        return $this->getTaskResultDao()->sumWatchTimeByCategoryIdAndUserId($categoryId, $userId);
    }

    public function waveLearnTime($id, $time)
    {
        $result = $this->getTaskResultDao()->wave(array($id), array(
            'time' => $time,
        ));

        $this->dispatchEvent('wave.learn.time', new Event($id, array('learnTime' => $time)));

        return $result;
    }

    public function findFinishedTimeGroupByUserId(array $courseIds)
    {
        return $this->getTaskResultDao()->findFinishedTimeGroupByUserId($courseIds);
    }

    public function getTaskResultById($id)
    {
        return $this->getTaskResultDao()->get($id);
    }

    public function sumLearnTimeByCourseIdsAndUserIdsGroupByUserId(array $courseIds, array $userIds)
    {
        return $this->getTaskResultDao()->sumLearnTimeByCourseIdsAndUserIdsGroupByUserId($courseIds, $userIds);
    }

    public function sumLearnTimeByCourseId($courseId)
    {
        return $this->getTaskResultDao()->sumLearnTimeByCourseId($courseId);
    }
}
