<?php

namespace CorporateTrainingBundle\Biz\Taxonomy\Service\Impl;

use Biz\Taxonomy\Service\Impl\CategoryServiceImpl as BaseService;

class CategoryServiceImpl extends BaseService
{
    public function findCategories($groupId)
    {
        $group = $this->getGroup($groupId);

        if (empty($group)) {
            throw $this->createServiceException("分类Group #{$groupId}，不存在");
        }

        return $this->getCategoryDao()->findByGroupId($group['id']);
    }

    public function countCategories($conditions)
    {
        return $this->getCategoryDao()->count($conditions);
    }

    public function initOrgsRelation()
    {
        $fields = array('1', '1.');

        return $this->getCategoryDao()->initOrgsRelation($fields);
    }

    public function searchCategories(array $conditions, array $orderBys, $start, $limit)
    {
        return $this->getCategoryDao()->search($conditions, $orderBys, $start, $limit);
    }

    public function findCategoriesByGroupCodeAndNames($groupCode, array $names)
    {
        $categoryGroup = $this->getGroupByCode($groupCode);

        if (empty($categoryGroup)) {
            return array();
        }

        return $this->getCategoryDao()->findByGroupIdAndNames($categoryGroup['id'], $names);
    }
}
