<?php

namespace CorporateTrainingBundle\Biz\TrainingAssignment\Dao\Impl;

use Codeages\Biz\Framework\Dao\GeneralDaoImpl;
use CorporateTrainingBundle\Biz\TrainingAssignment\Dao\TrainingAssignmentDao;

class TrainingAssignmentDaoImpl extends GeneralDaoImpl implements TrainingAssignmentDao
{
    protected $table = 'training_assignment';

    public function declares()
    {
        return array(
            'timestamps' => array('createdTime', 'updatedTime'),
            'orderbys' => array('id', 'createdTime', 'updatedTime'),
            'serializes' => array('cover' => 'json'),
            'conditions' => array(
                'id = :id',
                'status = :status',
                'name LIKE :nameLike',
                'createdUserId = :createdUserId',
                'startTime >= :startTime_GE',
                'startTime <= startTime_LE',
                'endTime >= :endTime_GE',
                'endTime <= :endTime_LE',
                'id IN ( :ids )',
                'orgId = :orgId',
                'orgId IN ( :orgIds )',
                'orgCode = :orgCode',
                'orgCode Like :likeOrgCode',
            ),
        );
    }
}
