<?php

namespace CorporateTrainingBundle\Biz\TrainingAssignment\Dao\Impl;

use Codeages\Biz\Framework\Dao\GeneralDaoImpl;
use CorporateTrainingBundle\Biz\TrainingAssignment\Dao\TrainingAssignmentItemDao;

class TrainingAssignmentItemDaoImpl extends GeneralDaoImpl implements TrainingAssignmentItemDao
{
    protected $table = 'training_assignment_item';

    public function findByTargetIdAndTargetType($targetId, $targetType)
    {
        return $this->findByFields(array('targetId' => $targetId, 'targetType' => $targetType));
    }

    public function findByAssignmentId($assignmentId)
    {
        return $this->findByFields(array('assignmentId' => $assignmentId));
    }

    public function findByAssignmentIds($assignmentIds)
    {
        return $this->findInField('assignmentId', $assignmentIds);
    }

    public function findByAssignmentIdAndTargetType($assignmentId, $targetType)
    {
        return $this->findByFields(array('assignmentId' => $assignmentId, 'targetType' => $targetType));
    }

    public function deleteItemByAssignmentId($assignmentId)
    {
        $sql = "DELETE FROM {$this->table} WHERE assignmentId = ?";

        return $this->db()->executeUpdate($sql, array($assignmentId));
    }

    public function declares()
    {
        return array(
            'timestamps' => array('createdTime', 'updatedTime'),
            'orderbys' => array(
                'id',
                'createdTime',
                'updatedTime',
                'seq',
            ),
            'conditions' => array(
                'id = :id',
                'id IN (:ids)',
                'assignmentId = :assignmentId',
                'targetType = :targetType',
                'targetId = :targetId',
                'targetId IN (:targetIds)',
                'assignmentId IN (:assignmentIds)',
            ),
        );
    }
}
