<?php

namespace CorporateTrainingBundle\Biz\TrainingAssignment\Dao\Impl;

use Codeages\Biz\Framework\Dao\GeneralDaoImpl;
use CorporateTrainingBundle\Biz\TrainingAssignment\Dao\TrainingAssignmentMemberDao;

class TrainingAssignmentMemberDaoImpl extends GeneralDaoImpl implements TrainingAssignmentMemberDao
{
    protected $table = 'training_assignment_member';

    public function getByUserIdAndAssignmentId($userId, $assignmentId)
    {
        return $this->getByFields(array('userId' => $userId, 'assignmentId' => $assignmentId));
    }

    public function findByUserId($userId)
    {
        return $this->findByFields(array('userId' => $userId));
    }

    public function findByAssignmentId($assignmentId)
    {
        return $this->findByFields(array('assignmentId' => $assignmentId));
    }

    public function deleteMemberByAssignmentId($assignmentId)
    {
        $sql = "DELETE FROM {$this->table} WHERE assignmentId = ?";

        return $this->db()->executeUpdate($sql, array($assignmentId));
    }

    public function declares()
    {
        return array(
            'timestamps' => array('createdTime', 'updatedTime'),
            'orderbys' => array('id', 'createdTime', 'updatedTime'),
            'conditions' => array(
                'id = :id',
                'assignmentId = :assignmentId',
                'userId = :userId',
                'id IN ( :ids)',
                'finishedTime = :finishedTime',
                'userId IN ( :userIds)',
                'assignmentId IN ( :assignmentIds)',
                'status = :status',
                'status IN ( :statuses)',
                'finishedTime > :finishedTime_GT',
            ),
        );
    }
}
