<?php

namespace CorporateTrainingBundle\Biz\TrainingAssignment\Service;

interface TrainingAssignmentMemberService
{
    public function getTrainingAssignmentMember($id);

    public function getTrainingAssignmentMemberByUserIdAndAssignmentId($userId, $assignmentId);

    public function findMembersByUserId($userId);

    public function findMembersByAssignmentId($assignmentId);

    public function createTrainingAssignmentMember($member);

    public function updateTrainingAssignmentMember($id, $fields);

    public function countTrainingAssignmentMembers(array $conditions);

    public function searchTrainingAssignmentMembers(array $conditions, array $orderBys, $start, $limit);

    public function deleteTrainingAssignmentMember($id);

    public function deleteMemberByAssignmentId($assignmentId);

    public function isBelongToUserAssignment($userId, $itemId, $type);

    public function batchBecomeMember($assignmentId, $userIds);

    public function batchDeleteMembers($assignmentId, $memberIds);
}
