<?php

namespace CorporateTrainingBundle\Biz\TrainingAssignment\Strategy;

use Codeages\Biz\Framework\Context\Biz;

class BaseAssignmentStrategy
{
    protected $biz;

    public function __construct(Biz $biz)
    {
        $this->biz = $biz;
    }

    /**
     * @return \CorporateTrainingBundle\Biz\TrainingAssignment\Service\Impl\TrainingAssignmentServiceImpl
     */
    protected function getTrainingAssignmentService()
    {
        return $this->createService('CorporateTrainingBundle:TrainingAssignment:TrainingAssignmentService');
    }

    /**
     * @return \CorporateTrainingBundle\Biz\TrainingAssignment\Service\Impl\TrainingAssignmentItemServiceImpl
     */
    protected function getTrainingAssignmentItemService()
    {
        return $this->createService('CorporateTrainingBundle:TrainingAssignment:TrainingAssignmentItemService');
    }

    /**
     * @return \CorporateTrainingBundle\Biz\TrainingAssignment\Service\Impl\TrainingAssignmentMemberServiceImpl
     */
    protected function getTrainingAssignmentMemberService()
    {
        return $this->createService('CorporateTrainingBundle:TrainingAssignment:TrainingAssignmentMemberService');
    }

    protected function createService($alias)
    {
        return $this->biz->service($alias);
    }
}
