<?php

namespace CorporateTrainingBundle\Biz\TrainingAssignment\Strategy;

use Codeages\Biz\Framework\Context\Biz;
use Codeages\Biz\Framework\Service\Exception\NotFoundException;
use CorporateTrainingBundle\Biz\TrainingAssignment\Service\TrainingAssignmentItemService;

class StrategyContext
{
    protected $biz;

    public function __construct(Biz $biz)
    {
        $this->biz = $biz;
    }

    public function createStrategy()
    {
        $strategyType = $this->getStrategyType('course');

        if (!isset($this->biz[$strategyType])) {
            throw new NotFoundException("assignment strategy {$strategyType} does not exist");
        }

        return $this->biz[$strategyType];
    }

    protected function getStrategyType($type)
    {
        return $type.'_assignment';
    }

    /**
     * @return TrainingAssignmentItemService
     */
    protected function getAssignmentItemService()
    {
        return $this->createService('CorporateTrainingBundle:TrainingAssignment:TrainingAssignmentItemService');
    }

    protected function createService($alias)
    {
        return $this->biz->service($alias);
    }
}
