<?php

namespace CorporateTrainingBundle\Biz\TrainingAssignment\Strategy;

use AppBundle\Extension\Extension;
use CorporateTrainingBundle\Biz\TrainingAssignment\Strategy\Impl\CourseAssignmentStrategyImpl;
use Pimple\Container;
use Pimple\ServiceProviderInterface;

class StrategyProvider extends Extension implements ServiceProviderInterface
{
    public function register(Container $biz)
    {
        $biz['assignment_strategy_context'] = function ($biz) {
            return new StrategyContext($biz);
        };

        $biz['course_assignment'] = function ($biz) {
            return new CourseAssignmentStrategyImpl($biz);
        };
    }
}
