<?php

namespace CorporateTrainingBundle\Biz\User\Job;

use Biz\Crontab\Service\Job;
use Topxia\Service\Common\ServiceKernel;

class SyncMaxUsersNumberJob implements Job
{
    public function execute($params)
    {
        $maxUsersNumber = $this->getUserService()->getMaxUsersNumber();
        $syncUsersNumber = $this->getEduCloudService()->syncMaxUsersNumber();
        if ($maxUsersNumber != $syncUsersNumber) {
            $this->getSettingService()->set('max_users_number', $syncUsersNumber);
        }
    }

    protected function getEduCloudService()
    {
        return $this->getServiceKernel()->createService('CorporateTrainingBundle:CloudPlatform:EduCloudService');
    }

    protected function getUserService()
    {
        return $this->getServiceKernel()->createService('CorporateTrainingBundle:User:UserService');
    }

    protected function getSettingService()
    {
        return $this->getServiceKernel()->createService('System:SettingService');
    }

    protected function getServiceKernel()
    {
        return ServiceKernel::instance();
    }
}
