<?php

namespace CorporateTrainingBundle\Common;

use AppBundle\Common\ArrayToolkit;

class TreeToolkit
{
    /**
     * [maketree description].
     *
     * @param array    $data     需要排序的数组,本身要支持层级关系
     * @param [string] $parentId
     * @param string   $sort     排序的字段
     *
     * @return [array] tree data
     */
    public static function makeTree(array $data, $sort, $parentId = 0, $nodeName = 'nodes')
    {
        $tree = self::makeParentTree($data, $sort, $parentId);

        foreach ($tree as $key => $value) {
            $tree[$key][$nodeName] = self::maketree($data, $sort, $value['id']);
        }

        return $tree;
    }

    private static function makeParentTree(array $data, $sort, $parentId)
    {
        $filtered = array();

        foreach ($data as $value) {
            if ($value['parentId'] == $parentId) {
                $filtered[] = $value;
            }
        }

        $sortArray = ArrayToolkit::column($filtered, $sort);

        array_multisort($sortArray, $filtered);

        return $filtered;
    }
}
