<?php

namespace CorporateTrainingBundle\Controller\Admin;

use AppBundle\Common\Paginator;
use AppBundle\Controller\Admin\BaseController;
use CorporateTrainingBundle\Biz\OfflineCourse\Service\OfflineCourseService;
use Symfony\Component\HttpFoundation\Request;

class OfflineCourseController extends BaseController
{
    public function listAction(Request $request)
    {
        $conditions = $request->query->all();

        $offlineCoursesCount = $this->getOfflineCourseService()->countOfflineCourses($conditions);
        $paginator = new Paginator($this->get('request'), $offlineCoursesCount, 10);
        $offlineCourses = $this->getOfflineCourseService()->searchOfflineCourses(
            $conditions,
            array('createdTime' => 'DESC'),
            $paginator->getOffsetCount(),
            $paginator->getPerPageCount()
        );

        return $this->render('admin/offline-course/index.html.twig', array(
            'offlineCourses' => $offlineCourses,
            'offlineCoursesCount' => $offlineCoursesCount,
            'paginator' => $paginator,
        ));
    }

    /**
     * @return OfflineCourseService
     */
    protected function getOfflineCourseService()
    {
        return $this->createService('CorporateTrainingBundle:OfflineCourse:OfflineCourseService');
    }
}
