<?php

namespace CorporateTrainingBundle\Extensions\DataTag;

use AppBundle\Extensions\DataTag\DataTag;
use AppBundle\Extensions\DataTag\BaseDataTag;

class TaskSumWatchTimeDataTag extends BaseDataTag implements DataTag
{
    public function getData(array $arguments)
    {
        $this->checkUserId($arguments);
        $this->checkTaskId($arguments);

        return $this->getTaskResultService()->sumWatchTimeByTaskIdAndUserId($arguments['taskId'], $arguments['userId']);
    }

    protected function checkUserId(array $arguments)
    {
        if (empty($arguments['userId'])) {
            throw new \InvalidArgumentException($this->getServiceKernel()->trans('userId参数缺失'));
        }
    }

    protected function checkTaskId(array $arguments)
    {
        if (empty($arguments['taskId'])) {
            throw new \InvalidArgumentException($this->getServiceKernel()->trans('taskId参数缺失'));
        }
    }

    protected function getTaskResultService()
    {
        return $this->getServiceKernel()->getBiz()->service('Task:TaskResultService');
    }
}
