define(function(require, exports, module){
  require('jquery.sortable');
  var Notify = require('common/bootstrap-notify');

  exports.run = function() {
    $('.post-course-delete').click(function(){
      if (!confirm(Translator.trans('确定删除该岗位课程吗？'))) {
        return;
      };

      $.post($(this).data('url'), function(result){
        if (result.success) {
          Notify.success(Translator.trans('删除成功！'));
          window.location.reload();
        } else {
          Notify.danger(Translator.trans('删除失败！'));
        }
      });
    });

    var $list = $('.post-courses-list').sortable({
      distance: 20,
      itemSelector: '.sortable-item',
      onDrop: function (item, container, _super) {
        _super(item, container);
        sortList($list);
      },
      serialize: function(parent, children, isContainer) {
        return isContainer ? children : parent.attr('data-id');
      }
    });

    var sortList = function($list) {
      var data = $list.sortable('serialize').get();
      $.post($list.data('sortUrl'), {ids:data}, function(result){
        if (result.success){
          $(".sortable-item").each(function(index){
            $(this).find('.post-course-seq').html(index+1);
          });
          Notify.success(Translator.trans(result.message));
        }
      }).fail(function() {
        Notify.danger(Translator.trans('更新学习顺序失败'));
      });
    };
  }
});