define(function (require, exports, module) {
    var Notify = require('common/bootstrap-notify');
    var Validator = require('bootstrap.validator');
    require('common/validator-rules').inject(Validator);
    exports.run = function () {
        var ids = [];
        $("[data-role='batch-item']:checked").each(function () {
            var id = $(this).parents('tr').attr('id');
            var userId = id.split('-').pop();
            if ($("#module").val() == "user" && userId == $("#appUserId").val()) {
                $(this).prop("checked", false);
                $(".js-user-help").removeClass("hidden");
                return;
            }
            ids.push(userId);
        });
        if(ids.length == 0 ){
            $("#batch-setting-post-btn").addClass("disabled")
        }
        $("#batch-ids").val(ids);

		var $modal = $('#batch-setting-post-form').parents('.modal');
		var validator = new Validator({
			element: '#batch-setting-post-form',
			autoSubmit: false,
			onFormValidated: function(error, results, $form) {
				if (error) {
					return false;
				}
				$.post($form.attr('action'), $form.serialize(), function(result) {
					$modal.modal('hide');
					Notify.success(Translator.trans('更新岗位成功'));
					setTimeout(function(){
						window.location.reload();
					},1000);
				}).error(function() {
					Notify.danger(Translator.trans('操作失败'));
				});
			}
		});

        validator.addItem({
            element: '[name="batchNewPostId"]',
            required: true,
            display: '岗位'
        });

        var $postsContainer = $('#batchModalPostId');
        $postsContainer.select2({
            ajax: {
                url: $postsContainer.data('url'),
                dataType: 'json',
                quietMillis: 100,
                data: function (term, page) {
                    return {
                        q: term,
                        page_limit: 10
                    };
                },
                results: function (data) {
                    var results = [];
                    $.each(data, function (index, item) {

                        results.push({
                            id: item.id,
                            name: item.name
                        });
                    });

                    return {
                        results: results
                    };

                }
            },
            formatSelection: function (item) {
                return item.name;
            },
            formatResult: function (item) {
                return item.name;
            }
        });
	};

});