import notify from 'common/notify';

let $form = $('#member-create-form');
let $modal = $form.parents('.modal');
let $btn = $('#member-create-btn');

let validator = $form.validate({
  onkeyup: false,
  rules: {
    queryfield: {
      required: true,
      remote: {
        url: $('#queryfield').data('url'),
        type: 'get',
        data: {
          'value': function () {
            return $('#queryfield').val();
          }
        }
      }
    }
  },
  messages: {
    queryfield: {
      remote: Translator.trans('请输入学员邮箱/手机号/用户名')
    }
  }
});

const formValidate = () => {
  if (validator.form()) {
    $btn.button('submiting').addClass('disabled');
    $.post($form.prop('action'), $form.serialize(), function(result){
      if (result.success) {
        $modal.modal('hide');
        notify('success', Translator.trans('添加成功!'));
        window.location.reload();
      } else {
        notify('danger', Translator.trans('添加失败!'));
        $btn.button('reset').removeClass('disabled');
      }
    }).error(function() {
      notify('danger', Translator.trans('添加失败!'));
      $btn.button('reset').removeClass('disabled');
    });;
  };
}

$('.js-add-member').keydown((event) => {
  if (event.keyCode == 13) {
    formValidate();
  }
})

$btn.click(() => {
  formValidate();
});
