export default class Create {
    constructor($element) {
        this.$element = $element;
        this.init();
    }

    init() {
        this.validator = this.$element.validate({
            currentDom: '#offline-course-create-btn',
            rules: {
                title: {
                    byte_maxlength: 60,
                    chinese_alphanumeric: true,
                    required: true,
                    trim: true,
                    course_title: true,
                },
                categoryId: {
                    required: {
                        depends () {
                            $(this).val($.trim($(this).val()));
                            return true;
                        }
                    }
                }
            },
            messages: {
                title: {
                    required: Translator.trans('请输入标题'),
                    trim: Translator.trans('请输入标题'),
                },
                categoryId: {
                    required: Translator.trans('请选择分类'),
                    trim: Translator.trans('请选择分类'),
                }
            }
        });
        $('#offline-course-create-btn').on('click', (e) => {
            let $target = $(e.target);
            if (this.validator.form()) {
                this.$element.submit();
            }
        });
    }
}