import notify from 'common/notify';

let total = $('#offline-course-container').data('total');
let currentIndex = 0;
let numPerPage = 5;

if (total > 0) {
    ajaxGetRowHtml($('#offline-course-container').data('url'));
    $(window).scroll(function(){
        if($(window).scrollTop() + $(window).height() == $(document).height()) {
            $('.js-offline-course-more').trigger('click');
        }
    });
} else {
    $('#offline-course-container').append('<div class="empty">暂无活动</div>');
    $('.js-offline-course-more').addClass('hidden');
}

function ajaxGetRowHtml(url){
    $('.js-offline-course-more').html('加载中...');
    $('.js-offline-course-more').addClass('disabled');

    url = url+'&start='+currentIndex;
    $.ajax({
        url: url,
        type: 'get',
        dataType: 'html',
    }).success( function(data) {
        $('#offline-course-container').append(data);
        currentIndex = currentIndex+numPerPage;
        if(currentIndex >= total){
            $('.js-offline-course-more').addClass('hidden');
        }
    }).fail( function(err) {
        notify('danger',Translator.trans('加载失败'));
    }).complete( function(){
        $('.js-offline-course-more').html('加载更多');
        $('.js-offline-course-more').removeClass('disabled');
    });
}

$('.js-offline-course-more').on('click', function(e) {
    if($(this).hasClass('disabled')){
        return;
    }
    let url = $('#offline-course-container').data('url');
    ajaxGetRowHtml(url);
});