export default class Base {
    constructor() {
        this.init();
        this.initCkeditor()
    }

    init() {
        const $form = $('#assignment-base-form');
        this.data = {};

        const validator = $form.validate({
            rules: {
                name: {
                    byte_maxlength: 40,
                    chinese_alphanumeric: true,
                    required: true,
                    trim: true,
                },
                startDateTime: {},
                endDateTime: {
                    endDate_check: true,
                }
            },
            messages: {
                name: {
                    required: Translator.trans('请输入项目名称'),
                    trim: Translator.trans('请输入项目名称'),
                }
            }
        });

        this.initDatePicker('#startDateTime');
        this.initDatePicker('#endDateTime');


        $('#assignment-base-submit').on('click', (e) => {

            if (validator.form()) {
                $('#assignment-base-submit').button('loading');
                $form.submit();
            }
        });
    }

    initCkeditor() {
        CKEDITOR.replace('summary', {
            allowedContent: true,
            toolbar: 'Detail',
            filebrowserImageUploadUrl: $('#assignment_description').data('imageUploadUrl')
        });
    }

    initDatePicker($id) {
        let $picker = $($id);
        $picker.datetimepicker({
            format: 'yyyy-mm-dd',
            language: document.documentElement.lang,
            minView: 'month',
            autoclose: true,
            endDate: new Date(Date.now() + 86400 * 365 * 10 * 1000)
        });
        $picker.datetimepicker('setStartDate', new Date());
    }
}


jQuery.validator.addMethod("endDate_check", function () {
    var startDate = $('[name="startDateTime"]').val();
    var endDate = $('[name="endDateTime"]').val();
    return (startDate <= endDate);
}, "结束时间大于或等于开始时间");



