export default class Create {
    constructor($element) {
        this.$element = $element;
        this.init();
    }

    init() {
        this.validator = this.$element.validate({
            currentDom: '#offline-course-create-btn',
            rules: {
                name: {
                    byte_maxlength: 40,
                    chinese_alphanumeric: true,
                    required: true,
                    trim: true,
                },
            },
            messages: {
                name: {
                    required: Translator.trans('请输入项目名称'),
                    trim: Translator.trans('请输入项目名称'),
                },
            }
        });

        $('#assignment-create-btn').on('click', (e) => {
            let $target = $(e.target);
            if (this.validator.form()) {
                $('#assignment-create-btn').button('loading').addClass('disabled');
                this.$element.submit();
            }
        });
    }

}

