import notify from 'common/notify';

export default class Base {
    constructor() {
        this.init();
    }

    init() {
        const self = this;
        const $form = $('#assignment-item-form');
        this.data = {};

        let $postsContainer = $('#changeModalTargetId');
        $postsContainer.select2({
            ajax: {
                url: $postsContainer.data('url'),
                dataType: 'json',
                quietMillis: 100,
                data: function (term, page) {
                    return {
                        q: term,
                        page_limit: 10
                    };
                },
                results: function (data) {
                    console.log(data);
                    var results = [];
                    $.each(data, function (index, item) {

                        results.push({
                            id: item.id,
                            name: item.name + '；编号：' + item.id
                        });
                        self.data[item.id] = item.name;
                    });

                    return {
                        results: results
                    };

                }
            },
            initSelection (element, callback) {
                // var id = $(element).val();
                // var targetType = $('#targetType').val();
                // var url = '';
                // if (id !== "") {
                //     if (targetType == 'course') {
                //         url = $("#js-course-search").data('url')+'?id=' + id;
                //     }
                //     if (url != '') {
                //         $.ajax(url, {
                //             dataType: "json"
                //         }).success(function(resp) {
                //             var data = ({
                //                 id: resp.id,
                //                 name: resp.name + '，编号:' + resp.id,
                //             });
                //             callback(data);
                //         });
                //     }
                // }
            },
            formatSelection: function (item) {
                return item.name;
            },
            formatResult: function (item) {
                return item.name;
            },
            placeholder: Translator.trans('输入课程标题关键字搜索更多课程')
        });

        $postsContainer.on("select2-selected", function (e) {
            const exp = new RegExp(`(^|,)${e.val}($|,)`, 'ig');

            if (!exp.test($('[name=assignmentCourses]').val())) {
                self.$sortable.append(self.renderSortableItem({
                    id: e.val,
                    name: self.data[e.val]
                }));
                self.setSortableValue();
            } else {
                notify('warning', '重复添加课程');
            }

        });

        $('#assignment-base-submit').on('click', (e) => {
            $form.submit();
        });

        this.initsortable();
    }

    initsortable() {
        let $sortable = $('.js-ct-sortable');
        this.$sortable = $sortable;
        let self = this;
        $sortable.sortable({
            distance: 20,
            onDrop: function ($item, container, _super) {
                self.setSortableValue();
                _super($item, container);
            },

            serialize: function (parent, children, isContainer) {
                return isContainer ? children.join() : $(parent).data('id');
            }
        });

        $sortable.on('click', '.js-close-icon', function () {
            $(this).parent().remove();
            self.setSortableValue();
        });
    }

    setSortableValue() {
        let $sortable = this.$sortable;
        $('[name=assignmentCourses]').val($sortable.sortable("serialize").get()[0]);
    }

    renderSortableItem(opts) {
        return `<li class="training-assignment-sortable-item" data-id="${opts.id}">
                    <i class="training-assignment-sortable-item__icon es-icon es-icon-yidong mrl gray-medium vertical-middle"></i>
                    <span class="training-assignment-sortable-item__info">
                      课程：${opts.name}
                    </span>
                    <span class="gray-medium">；</span>
                    <span class="training-assignment-sortable-item__info">编号：${opts.id}</span>
                        <a class="training-assignment-sortable-item__close-btn js-close-icon" href="javascript:;">
                            <i class="es-icon es-icon-close01 pull-right "></i>
                        </a>
                </li>`;
    }
}



