import CheckTreeviewInput from '../../common/CheckTreeview-input';
import notify  from 'common/notify';
class List {
    constructor() {
        this.initTreeViewInput();
        this.initSelect();
        this.initBatchDelete();
        this.initAssignmentOperate();
        this.initSearchCondition();
    }
    initSelect() {
        $('[data-role="tree-select"], [name="categoryId"]').select2({
            treeview: true,
            dropdownAutoWidth: true,
            treeviewInitState: 'collapsed',
            placeholderOption: 'first',
            allowClear: true,
        });
    }
    initTreeViewInput() {
        let $treeview = $('.js-treeview-select-wrap');
        for (let i = 0; i < $treeview.length; i++) {
            new CheckTreeviewInput({$elem: $treeview.eq(i)})
        }
    }
    initBatchDelete() {
        var $element = $('#training-assignment-member-container');
        $element.on('click', '[data-role=batch-select]', function () {
            if ($(this).is(":checked") == true) {
                $element.find('[data-role=batch-select], [data-role=batch-item]').prop('checked', true);
            } else {
                $element.find('[data-role=batch-select], [data-role=batch-item]').prop('checked', false);
            }
        });
        $element.on('click', '[data-role=batch-item]', function () {
            var length = $element.find('[data-role=batch-item]').length;
            var checked_count = 0;
            $element.find('[data-role=batch-item]').each(function () {
                if ($(this).is(":checked")) {
                    checked_count++;
                }
                ;
            })
            if (checked_count == length) {
                $element.find('[data-role=batch-select]').prop('checked', true);
            } else {
                $element.find('[data-role=batch-select]').prop('checked', false);
            }
        });
        $element.on('click', '[data-role="batch-delete"]', function () {
            var $btn = $(this);
            name = $btn.data('name');
            var ids = [];
            $element.find('[data-role=batch-item]:checked').each(function () {
                ids.push(this.value);
            });
            console.log(ids.length);
            if (ids.length == 0) {
                notify('danger', '未选中任何' + name);
                return;
            }
            if (!confirm(Translator.trans('确定要删除选中的%ids%条%name%吗？', {ids: ids.length, name: name}))) {
                return;
            }
            $element.find('.btn').addClass('disabled');
            notify('info', Translator.trans('正在删除%name%，请稍等。', {name: name}), 60);
            $.post($btn.data('url'), {ids: ids}, function () {
                window.location.reload();
            });
        });
    }
    initAssignmentOperate() {
        $('.assignment-operate').click(function () {
            let notifyTitle = $(this).data('notifyTitle');
            if (!confirm(`确定要${notifyTitle}`)) {
                return;
            }
            $.get($(this).data('url'), function (result) {
                if (result) {
                    notify('success', `${notifyTitle}成功!`);
                    window.location.reload();
                } else {
                    notify('danger', `${notifyTitle}失败!`);
                }
            }).error(function () {
                notify('danger', `${notifyTitle}失败!`);
            });
        });
    }
    initSearchCondition() {
        let $element = '#member-status';
        let value = $($element).find("option:selected").val();
        if (value == 'finished') {
            $('#choose-delay').removeClass('hidden')
        }
        $($element).change(function () {
            let value = $($element).find("option:selected").val();
            if (value == 'finished') {
                $('#choose-delay').removeClass('hidden')
            } else {
                $('#choose-delay').addClass('hidden')
            }
        })
    }
}
new List();