define(function(require, exports, module) {
  var Morris=require("morris");
  require("jquery.bootstrap-datetimepicker");
  var Validator = require('bootstrap.validator');
  require('common/validator-rules').inject(Validator);
  var now = new Date();

  exports.run = function() {
    var userActiveChart = function(){
      if($('#data').length > 0){
        var data = eval ("(" + $('#data').attr("value") + ")");
        Morris.Line({
          element: 'line-data',
          data: data,
          xkey: 'date',
          ykeys: ['count'],
          labels: [Translator.trans('登录人数')],
          xLabels:"day"
        });
      }
    }

    var $form = $('#operation-form');
    var ajaxData = function(){
      $form.on('click', '.js-data-btn', function(e) {
        $.post($('#operation-form').attr('action'), $form.serialize(), function(result){
          $('.user-active-chart').html(result);
          userActiveChart();
        }).fail(function(e){

        });
      });
    };

    var changeTime = function(){
      $('.js-data-btn').removeClass('active');
      $(this).addClass('active');

      $("[name=startTime]").prop("value", $(this).attr("monthStart"));
      $("[name=endTime]").prop("value", $(this).attr("monthEnd"));
    }

    if($('#data').length > 0){
      userActiveChart();
    }

    $('.js-data-popover').popover({
      html: true,
      trigger: 'hover',
      placement: 'bottom',
      content: $("#info-property-tips-html").html()
    });

    (function initDateTimpPicker() {
      $("[name=endTime]").datetimepicker({
        autoclose: true,
        format: 'yyyy-mm-dd',
        minView: 'month',
        endDate: now,
        startDate: $('#loginStartDate').attr("value")
      });
      $("[name=startTime]").datetimepicker({
        autoclose: true,
        format: 'yyyy-mm-dd',
        minView: 'month',
        endDate: now,
        startDate: $('#loginStartDate').attr("value")
      });
    })();

    $("#btn-month").on("click",function(){
      changeTime.call(this);
      ajaxData();
    });

    $("#btn-lastMonth").on("click",function(){
      changeTime.call(this);
      ajaxData();
    })

    $("#btn-lastThreeMonths").on("click",function(){
      changeTime.call(this);
      ajaxData();
    })

  };
});