define(function (require, exports) {
  var Notify = require('common/bootstrap-notify');

  exports.run = function () {
    var $table = $('#training-assignment-table');

    $table.on('click', '.close-training-assignment', function () {
      if (!confirm(Translator.trans('您确认要关闭此项目吗？'))) return false;
        $.post($(this).data('url'), function () {
        Notify.success(Translator.trans('项目关闭成功！'));
        window.location.reload();
      });
    });

    $table.on('click', '.delete-training-assignment', function () {
      if (!confirm(Translator.trans('您确认要删除此项目吗？'))) return false;
      $.post($(this).data('url'), function () {
        Notify.success(Translator.trans('删除项目成功！'));
        window.location.reload();
      });
    });

    $table.on('click', '.publish-training-assignment', function() {
      if (!confirm(Translator.trans('您确认要发布此项目吗？'))) return false;
      $.post($(this).data('url'), function(response) {
        if (!response['success']) {
          Notify.danger(response['message']);
        } else {
          Notify.success(Translator.trans('项目发布成功！'));
          window.location.reload();
        }
      }).error(function(e) {
        var res = e.responseJSON.error.message || '未知错误';
        Notify.danger(res);
      })
    });
  };
});
